//+------------------------------------------------------------------+
//|                                                 HeikenSample.mq4 |
//|                                   Copyright  2010, FOREX KNIGHT |
//|                                    http://davidke20.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, FOREX-TSD"
#property link      "http://davidke20.blogspot.com"

extern int TakeProfit = 50;
extern int StopLoss = 200;
extern double Lots = 0.1;
extern double TrailingStop = 30;
extern int MATrendPeriod = 14;
extern int MagicNumber=32768;
extern bool HouseKeeping=false;

double UpReference=0,DownReference=0;
string Flag="Range",Comm="",TimePer="";

//+------------------------------------------------------------------+
//| Global declaration                                               |
//+------------------------------------------------------------------+
int init()
{
//---- 
   if(MarketInfo(Symbol(),MODE_DIGITS)==3 || MarketInfo(Symbol(),MODE_DIGITS)==5)
   TakeProfit=TakeProfit*10;
   StopLoss=StopLoss*10;
   TrailingStop=TrailingStop*10;
   switch(Period())
   {
      case 1:TimePer="M1";
      case 5:TimePer="M5";
      case 15:TimePer="M15";
      case 30:TimePer="M30";
      case 60:TimePer="H1";
      case 240:TimePer="H4";
      case 1440:TimePer="D1";break;
   }
   Comm="HA "+Symbol()+" "+TimePer;
//----
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//---- 
   if(HouseKeeping)
   {
      for(int cnt=0; cnt<ObjectsTotal(); cnt++)
      ObjectsDeleteAll();
   }
//----
   return(0);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int MyTotalOrders()
{
   int MyOrderCount=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      MyOrderCount++;
   }
   return(MyOrderCount);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double HA0=iCustom(NULL,0,"Heiken Ashi",0,1);
   double HA1=iCustom(NULL,0,"Heiken Ashi",1,1);
   double HA2=iCustom(NULL,0,"Heiken Ashi",2,1);
   double HA3=iCustom(NULL,0,"Heiken Ashi",3,1);
   double HAHist=iCustom(NULL,0,"Heiken Ashi",3,2);
   double MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   double MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,2);
   
   if((HAHist<MaPrevious && HA3>HA2 && HA3>MaCurrent) || HA1==HA3)
   {
      Flag="UpTrend";
      UpReference=iHigh(NULL,0,1);
   }
   if((HAHist>MaPrevious && HA3<HA2 && HA3<MaCurrent) || HA0==HA2)
   {
      Flag="DownTrend";
      DownReference=iLow(NULL,0,1);
   }

   double SL=0,TP=0;

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }

   if(MyTotalOrders()<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(Flag=="UpTrend" && Ask>UpReference)
        {
         if(StopLoss>10)
         SL=Ask-StopLoss*Point;
         else
         SL=0;
         if(TakeProfit>10)
         TP=Ask+TakeProfit*Point;
         else
         TP=0;
         if(OrderSend(Symbol(),OP_BUY,Lots,Ask,3,SL,TP,Comm,MagicNumber,0,Blue)==-1)
         Print("Error opening buy order ,",GetLastError());
         return(0); 
        }
      // check for short position (SELL) possibility
      if(Flag=="DownTrend" && Bid<DownReference)
        {
         if(StopLoss>10)
         SL=Bid+StopLoss*Point;
         else
         SL=0;
         if(TakeProfit>10)
         TP=Bid-TakeProfit*Point;
         else
         TP=0;
         if(OrderSend(Symbol(),OP_SELL,Lots,Bid,3,SL,TP,Comm,MagicNumber,0,Red)==-1)
         Print("Error opening sell order ,",GetLastError());
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(int cnt=0;cnt<MyTotalOrders();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol() &&  // check for symbol
         OrderMagicNumber()==MagicNumber) // check for Magic Number
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Flag=="DownTrend")
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Flag=="UpTrend")
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.